#%RAML 1.0
title: Session Management
baseUri: https://gw-sandbox-qa.apps.ambientesbc.com/public-partner/sb/v1/operations/product-specific/loans/bnpl-product-information/auth
version: 1.0.0

securitySchemes:

types:
  BnplSessionManagementHRS: !include datatypes/BnplSessionManagementHRS.raml
  BnplSessionManagementErrors: !include datatypes/BnplSessionManagementErrors.raml
  BnplSessionCloseRQ: !include datatypes/BnplSessionCloseRQ.raml
  BnplSessionCloseRS: !include datatypes/BnplSessionCloseRS.raml
  BnplLoginRQ: !include datatypes/BnplLoginRQ.raml
  BnplLoginRS: !include datatypes/BnplLoginRS.raml
  BnplAuthenticationRQ: !include datatypes/BnplAuthenticationRQ.raml
  BnplAuthenticationRS: !include datatypes/BnplAuthenticationRS.raml
  

  newtype:
    type: string
    description: Llave para control de autenticación
/authentication:
  post:
    displayName: Authentication Resource
    description: Capacidad que permite generar la URL de redirección al FUA.
    headers:
      Message-Id:
        type: string
        description: ID del mensaje
        example: f4e23602-6b4d-4fb1-a4c3-acad97ec31dd
      x-apikey:
        type: string
        description: Llave para control de autenticación
    body: 
      application/json:
        type: BnplAuthenticationRQ
        example: !include examples/BnplAuthenticationRequest.raml
    responses: 
      200:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplAuthenticationRS
            example: !include examples/BnplAuthenticationrResponse.raml
      400:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplError400.raml
      401:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplAuthenticationError401.raml
      404:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplAuthenticationError404.raml      
      500:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplError500.raml
      502:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplError502.raml      
      503:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplError503.raml
      504:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplError504.raml
      
/login:
  post:
    displayName: Login Bnpl Bancolombia
    description: Genera la sesión de usuario en el producto BNPL (consulta del cupo pre-calculado Bancolombia), con el fin de generar un token de sesión.  
    headers:
      Message-Id:
        type: string
        description: ID del mensaje
        example: f4e23602-6b4d-4fb1-a4c3-acad97ec31dd
      x-apikey:
        type: string
        description: Llave para control de autenticación
    body: 
      application/json:
        type: BnplLoginRQ
        example: !include examples/BnplLoginRequest.raml
    responses: 
      200:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplLoginRS
            example: !include examples/BnplLoginResponse.raml 
      400:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplError400.raml
      401:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplLoginError401.raml
      404:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplLoginError404.raml      
      500:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplError500.raml
      502:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplError502.raml      
      503:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplError503.raml
      504:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplError504.raml
  
/session/close:
  post:
    displayName: Cierre de sesión Bnpl Bancolombia
    description: Cierra la sesión activa en Bnpl
    headers:
      Message-Id:
        type: string
        description: ID del mensaje
        example: f4e23602-6b4d-4fb1-a4c3-acad97ec31dd
      x-apikey:
        type: string
        description: Llave para control de autenticación
    body:
      application/json:
        type: BnplSessionCloseRQ
        example: !include examples/BnplSessionCloseRequest.raml
    responses:
      200:
        headers:
          type: BnplSessionManagementHRS
          
        body: 
          application/json:
            type: BnplSessionCloseRS
            example: !include examples/BnplSessionCloseResponse.raml 
      400:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplError400.raml
      401:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplSessionCloseError401.raml
      404:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplSessionCloseError404.raml      
      500:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplError500.raml
      502:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplError502.raml      
      503:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplError503.raml
      504:
        headers:
          type: BnplSessionManagementHRS
        body: 
          application/json:
            type: BnplSessionManagementErrors
            example: !include examples/BnplError504.raml
